# ifndef _RQA_PROXY_H
# define _RQA_PROXY_H
/*
  $Id: applet_proxy.h,v 1.3 2006/07/14 09:22:38 noir Exp $
  Copyright (C) 2006 Hiroyuki KUROSAKI <noir (at) st . rim . or . jp>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <qwidget.h>
#include <qpixmap.h>
#include <qevent.h>
#include <qpe/qcopenvelope_qws.h>

#include "ruby.h"

// #include "error_handler.h"

namespace RubyQpeApplet
{

class AppletProxy : public QWidget
{
    Q_OBJECT
public:
    AppletProxy(QWidget* parent = 0);
    ~AppletProxy();

private:
    VALUE         applet;
    VALUE         applet_class;
    int           ruby_state;
    QPixmap       taskbar_icon;
    void          init_applet();
    void          finalize_applet();
    void          init_taskbar_icon();
    void          init_qcop_channel();

protected:
    QCopChannel*  qcop_channel;
    void          paintEvent(QPaintEvent*);
    void          mousePressEvent(QMouseEvent*);

protected slots:
    void receive_message(const QCString& msg, const QByteArray& data);
    void reload();
};

};
#endif /* _RQA_PROXY_H */
