/*
  $Id: interface.cpp,v 1.3 2006/07/14 09:22:38 noir Exp $
  Copyright (C) 2006 Hiroyuki KUROSAKI <noir (at) st . rim . or . jp>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "interface.h"
#include "applet_proxy.h"

using namespace RubyQpeApplet;

Interface::Interface()
    : applet_proxy(0), ref(0)
{
}

Interface::~Interface()
{
    delete applet_proxy;
}

QWidget *Interface::applet(QWidget *parent)
{
    if (!applet_proxy) {
        applet_proxy = new AppletProxy(parent);
    }
    return applet_proxy;
}

int Interface::position() const
{
    return 8; /* ??? */
}

QRESULT Interface::queryInterface(const QUuid &uuid, QUnknownInterface **iface)
{
    *iface = 0;
    if (uuid == IID_QUnknown) {
        *iface = this;
    }
    else if (uuid == IID_TaskbarApplet) {
        *iface = this;
    }
    else {
        return QS_FALSE;
    }

    (*iface)->addRef();

    return QS_OK;
}

Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE(RubyQpeApplet::Interface)
}
