/*
  $Id: rb_funcall2_protect.cpp,v 1.2 2006/07/11 00:23:34 noir Exp $
  Copyright (C) 2006 Hiroyuki KUROSAKI <noir (at) st . rim . or . jp>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "rb_funcall2_protect.h"

struct rb_funcall2_args {
    rb_funcall2_args();
    rb_funcall2_args(VALUE r, ID m, int ac, const VALUE* av)
        : recv(r), mid(m), argc(ac), argv(av) {}
    VALUE        recv;
    ID           mid;
    int          argc;
    const VALUE *argv;
};

VALUE rb_funcall2_wrap(const rb_funcall2_args* args)
{
    return rb_funcall2(args->recv, args->mid, args->argc, args->argv);
}

VALUE rb_funcall2_protect(VALUE recv, ID mid, int argc, const VALUE* argv, int* p_error)
{
    rb_funcall2_args args(recv, mid, argc, argv);

    return rb_protect((VALUE (*)(VALUE))rb_funcall2_wrap,
                      (VALUE)&args,
                      p_error);
} 
